%function fig = showFunctionalMap(mesh1, mesh2, curves_1, curves_2, Fmap, Pmap, showcurves,texture, fig)
 function fig = showFunctionalMap(mesh1, mesh2, curves_1, curves_2, Fmap, showcurves,texture, fig)
    if nargin < 8
        fig = figure;
    end
    
    nbasis = size(mesh1.laplaceBasis,2);
    %kf = rand(nbasis,1)-0.5;
    %f = kf.*((nbasis:-1:1).^2');
    f = mesh1.laplaceBasis'*mesh1.Ae*mesh1.laplaceBasis(:,5);%
    %f = mesh1.laplaceBasis'*mesh1.Ae*(map.^2);

    subplot(1,4,1);
    trimesh(mesh1.T, mesh1.X(:,1), mesh1.X(:,2), mesh1.X(:,3),mesh1.laplaceBasis*f,'FaceColor','interp');
    hold on;
    if showcurves
        plotcurves(curves_1, mesh1.X);
    end
    %view([0 90]);
    title('f = eigenfunction 5');
    axis equal;
    axis off;

    subplot(1,4,2);
    trimesh(mesh2.T, mesh2.X(:,1), mesh2.X(:,2), mesh2.X(:,3),mesh2.laplaceBasis*Fmap*f,'FaceColor','interp');
    hold on;
    if showcurves
        plotcurves(curves_2, mesh2.X);
    end
    %view([0 90]);
    title('fmap(eigenfunction 5)');
    axis equal;
    axis off;
    
%     sp3 = subplot(1,5,3);
%     cla(sp3);
%     samples = euclidean_fps(mesh1,20);
%     for i=1:length(samples)
%         if samples(i)>size(Pmap)
%             samples(i)=1;
%         end
%     end
%     visualize_map_lines(mesh2, mesh1, Pmap, samples);
%     plotcurves(curves_2, mesh2.X);
%     points = mesh1.X;
%     xdiam = 3/2*(max(points(:,1))-min(points(:,1)));
%     points(:,1) = points(:,1) + xdiam;
%     plotcurves(curves_1, points);
%     %view([0 90]);
%     title('Map before ICP');
%     axis equal;
%     axis off;
    
    cols = [1,2,3];
    M1_vt = MESH_IO.generate_tex_coords(mesh1.X, cols(2), cols(3), 1);
    %M2_vt = M1_vt(Pmap,:);
    Fv = (mesh1.laplaceBasis')*mesh1.Ae*sparse(M1_vt);
    M2_vt = mesh2.laplaceBasis*Fmap*Fv;
    [M1_vt_scaled, colors1] = getColorFromTesture(M1_vt, texture);
    [M2_vt_scaled, colors2] = getColorFromTesture(M2_vt, texture);
    
    subplot(1,4,3);
    trimesh(mesh1.T, mesh1.X(:,1), mesh1.X(:,2), mesh1.X(:,3), 'facevertexcdata',colors1,'FaceColor','interp');
    hold on;
    if showcurves
        plotcurves(curves_1, mesh1.X);
    end
    axis equal;
    axis off;

    subplot(1,4,4);
    trimesh(mesh2.T, mesh2.X(:,1), mesh2.X(:,2), mesh2.X(:,3),'facevertexcdata',colors2,'FaceColor','interp');
    hold on;
    if showcurves
        plotcurves(curves_2, mesh2.X);
    end
    axis equal;
    axis off;

%     figure;
%     xf = mesh2.laplaceBasis*Fmap*(mesh1.laplaceBasis')*mesh1.Ae*sparse(mesh1.X);
%     scatter3(xf(:,1), xf(:,2), xf(:,3), 'r');
%     axis equal;
%     hold on;
%     x2f = mesh1.laplaceBasis*(mesh1.laplaceBasis')*mesh1.Ae*sparse(mesh1.X);
%     scatter3(x2f(:,1), x2f(:,2), x2f(:,3), 'b');
% 
%     figure;
%     scatter(M1_vt(:,1), M1_vt(:,2), 'b');
%     hold on;
%     scatter(M2_vt(:,1), M2_vt(:,2), 'r');
%     axis equal;

end