% function [C, matches] = icp_refine(L1, L2, C, nk)
%     Vs = L1;
%     Vt = L2;
%     n1 = size(L1,2);
%     n2 = size(L2,2);
%         
%     for k=1:nk
%         matches = knnsearch((C*Vs')',Vt);
%         W = L2\L1(matches,:);
%        % W = Vt(:,matches)*Vs';
%         [s,~,d] = svd(W);
%         C = s*eye(n2,n1)*d';
%         
% %        err = sum(sum((X-X(matches,:)).^2));
%         %fprintf('%d %f\n', k, err);
%     end
% end

function [C, matches] = icp_refine(L1, L2, C, nk)
    Vs = L1;
    Vt = L2;
    n1 = size(L1,2);
    n2 = size(L2,2);
    C = C';   
    for k=1:nk
        X1 = (C*Vs')';
        matches = knnsearch(X1,Vt);
        L11= L1(matches,:);
       W = L2\L11;
       % W = Vt(:,matches)*Vs';
        [s,~,d] = svd(W);
        C = s*eye(n2,n1)*d';
        
%        err = sum(sum((X-X(matches,:)).^2));
        %fprintf('%d %f\n', k, err);
    end
    
    C= C';
end